#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    int br[n];
    int lg[n];
    int rez[q];
    map<int, int> m;
    for(int i = 0; i < n; i++){
        cin >> br[i];
        lg[i] = log2(br[i]);
    }

    for(int i = 0; i < q; i++){
        int l, r, max = 0;
        cin >> l >> r;
        l--;
        r--;
        for(int i = l; i <= r; i++){
            m[lg[i]]++;
            if(m[lg[i]] > max){
                max = m[lg[i]];
            }
        }
        rez[i] = max;
        for(int i = l; i <= r; i++){
            m[lg[i]] = 0;
        }
    }
    for(int i = 0; i < q; i++){
        cout << rez[i] << '\n';
    }
    return 0;
}